]> git.pld-linux.org Git - packages/mysql.git/blob - mysql.init
- don't mark db error messages files with lang as these depend on db client settings...
[packages/mysql.git] / mysql.init
1 #!/bin/sh
2 #
3 # mysql         A very fast and reliable SQL database engine
4 #
5 # chkconfig:    2345 84 25
6 #
7 # description:  A very fast and reliable SQL database engine.
8
9 # Source function library
10 . /etc/rc.d/init.d/functions
11
12 # Get network config
13 . /etc/sysconfig/network
14
15 # Get service config
16 if [ -f /etc/sysconfig/mysql ]; then
17         . /etc/sysconfig/mysql
18 else
19         nls "Error: %s not found" /etc/sysconfig/mysql
20         nls "%s can't be run." MySQL
21         exit 1
22 fi
23
24 if [ -n "$MYSQL_DB_CLUSTERS" ]; then
25         nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
26 fi
27
28 if [ -f /etc/mysql/clusters.conf ]; then
29         MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
30         if [ -z "$MYSQL_DB_CLUSTERS" ]; then
31                 nls "Warning: there are no configured clusters."
32         fi
33
34 else
35         nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
36         if [ -z "$MYSQL_DB_CLUSTERS" ]; then
37                 nls "Warning: there are no configured clusters."
38                 nls "Using default cluster /var/lib/mysql (compatibility mode)"
39                 MYSQL_DB_CLUSTERS=/var/lib/mysql
40         fi
41 fi
42
43
44 # Check that networking is up
45 if is_yes "${NETWORKING}"; then
46         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
47                 msg_network_down MySQL
48                 exit 1
49         fi
50 else
51         exit 0
52 fi
53
54 sharedir=/usr/share/mysql
55
56 action="$1"
57
58 # any db cluster as command line argument?
59 if [ $# -gt 1 ]; then
60         shift
61         # perform action for specified clusters only
62         for a in "$@"; do
63                 # try auto resolving from /etc/mysql/clusters.conf
64                 if [[ "$a" != /* ]]; then
65                         m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66                         if [ -z "$m" ]; then
67                                 echo >&2 "Cluster name '$a' did not match anything!"
68                                 exit 1
69                         fi
70                         if [ $(echo "$m" | wc -l) -gt 1 ]; then
71                                 echo >&2 "Cluster name '$a' ambiguous:" $m
72                                 exit 1
73                         fi
74                         a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75                 fi
76                 DB_CLUSTERS="$DB_CLUSTERS $a"
77         done
78 else
79         DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80 fi
81
82 # global error log, if mysqld.conf hasn't migrated to log-error style
83 MYSQL_ERRLOG=/var/log/mysql/mysqld.log
84 MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86 #
87 # Useful functions.
88 #
89
90 #
91 # check for mysql status
92 #
93 # arguments:
94 # $1 - db cluster
95 # $2 - start|stop
96 #
97 # sets variables:
98 # MYSQL_STATUS = starting | running | not running | died
99 # MYSQL_PID    = pid of mysqld process
100 #
101 mysqlstatus() {
102         clusterdir="$1"
103         mode="$2"
104         
105         mysqlgetconfig "$clusterdir" status
106
107         MYSQL_STATUS="not running"
108         MYSQL_PID="unknown"
109         MYSQL_PIDFILE_PID=""
110         MYSQL_GREP_PID=""
111
112         if [ -f "$MYSQL_PIDFILE" ]; then
113                 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114         fi
115         
116         if [ -n "$MYSQL_PIDFILE_PID" ]; then
117                 MYSQL_PID=$MYSQL_PIDFILE_PID
118                 if [ ! -d "/proc/$MYSQL_PID" ]; then
119                         MYSQL_STATUS="died"
120                         return
121                 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122                         MYSQL_STATUS="running"
123                         return
124                 fi
125         fi
126
127         if [ "$mode" = "start" ]; then
128                 MYSQL_GREP_PID=$(grep -alE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129                 if [ -n "$MYSQL_GREP_PID" ]; then
130                         MYSQL_PID=$MYSQL_GREP_PID
131                         if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132                                 if [ -f "$MYSQL_PIDFILE" ]; then
133                                         MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134                                 fi
135                                 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136                                         MYSQL_PID=$MYSQL_PIDFILE_PID
137                                         MYSQL_STATUS="running"
138                                         return
139                                 else
140                                         MYSQL_STATUS="starting"
141                                         return
142                                 fi
143                         fi
144                 fi
145         fi
146
147         # else default, "not running"
148 }
149
150 # get mysql configuration in variables
151 # MYSQL_CONFIG MYSQL_CLUSTER_DIR
152 # MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153 #
154 # arguments
155 # $1 - db cluster
156 # $2 - status | other
157
158 mysqlgetconfig() {
159         local clusterdir="$1" config_file
160         local mode="$2"
161
162         # emulate old behaviour if only one cluster specified
163         if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
164                 MYSQL_RA_COMPAT=yes
165                 config_file=/etc/mysqld.conf
166         else
167                 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
168                 if [[ $config = /* ]]; then
169                         config_file="$config"
170                 elif [ -f "/etc/mysql/$config" ]; then
171                         config_file="/etc/mysql/$config"
172                 else
173                         config_file="$clusterdir/mysqld.conf"
174                 fi
175         fi
176
177         MYSQL_CLUSTER_DIR="$clusterdir"
178
179         if [ -z "$config_file" ]; then
180                 nls "Error: Can't find config file for %s cluster" "$clusterdir"
181                 if [ "$mode" = "status" ]; then 
182                         exit 3
183                 else
184                         exit 6
185                 fi
186         else
187                 MYSQL_CONFIG="$config_file"
188         fi
189
190         if [ ! -f "$config_file" ]; then
191                 nls "Error: config file %s not found" "$config_file"
192                 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
193                 if [ "$mode" = "status" ]; then 
194                         exit 3
195                 else
196                         exit 6
197                 fi
198         fi
199
200         # reset to initial state
201         MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
202
203         eval `awk -F= '
204         {
205                 # undos
206                 gsub(/\r$/, "");
207
208                 # trim spaces
209                 gsub(/^[\t ]+|[\t ]+$/, "", $1);
210                 gsub(/^[\t ]+|[\t ]+$/, "", $2);
211         }
212
213         # skip comments and empty lines
214         /^[;#]|^ *$/ { next }
215
216         /^[ \t]*\[.*\][ \t]*$/ {
217                 match($0, /\[.*\]/);
218                 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
219                 next;
220         }
221
222         section == "mysqld" {
223                 if ($1 == "datadir") {
224                         printf("MYSQL_DATA_DIR=%s;", $2);
225                 } else if ($1 == "user") {
226                         printf("MYSQL_USER=%s;", $2);
227                 } else if ($1 == "pid-file") {
228                         printf("MYSQL_PIDFILE=%s;", $2);
229                 } else if ($1 == "socket") {
230                         printf("MYSQL_SOCKET=%s;", $2);
231                 } else if ($1 == "port") {
232                         printf("MYSQL_PORT=%s;", $2);
233                 } else if ($1 == "bind-address") {
234                         printf("MYSQL_BIND_ADDRESS=%s;", $2);
235                 } else if ($1 == "skip-networking") {
236                         printf("MYSQL_SKIP_NETWORKING=1;");
237                 } else if ($1 == "log-error") {
238                         printf("MYSQL_LOG_ERROR=%s;", $2);
239                 }
240         }
241         ' $config_file`
242
243         # error log not defined in config file. add one
244         if [ -z "$MYSQL_LOG_ERROR" ]; then
245                 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
246         else
247                 # unset, so mysqld would use value from config itself
248                 unset MYSQL_LOG_ERROR
249         fi
250
251         if is_yes "$MYSQL_RA_COMPAT"; then
252                 MYSQL_DATA_DIR_SUB=""
253         else
254                 MYSQL_DATA_DIR_SUB="/mysqldb"
255         fi
256
257         if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
258                 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
259                 nls " MySQL can't be run."
260                 exit 6
261         fi
262
263         if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
264                 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
265                 nls " MySQL can't be run."
266                 exit 6
267         fi
268
269         if [ -z "$MYSQL_USER" ]; then
270                 echo "$(nls 'MySQL user not configured properly')"'!' >&2
271                 nls "Edit %s and configure it." "$config_file" >&2
272                 exit 6
273         fi
274 }
275
276 # start mysql
277 mysqlstart() {
278         local clusterdir="$1"
279         mysqlgetconfig "$clusterdir"
280         if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
281                 nls "MySQL cluster %s not initialized." "$clusterdir"
282                 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
283                 exit 6
284         fi
285
286         msg_starting "MySQL $clusterdir"; busy
287         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
288         rm -f "$MYSQL_PIDFILE"
289
290
291         TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
292                 /usr/bin/setsid /usr/sbin/mysqld \
293                         --defaults-file=$MYSQL_CONFIG \
294                         --datadir=$MYSQL_DATA_DIR \
295                         --pid-file=$MYSQL_PIDFILE \
296                         ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
297                         $MYSQL_OPTIONS &
298         pid=$!
299
300         sleep 0.1
301         mysqlstatus "$clusterdir" start
302         # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
303         if [ "$MYSQL_STATUS" = "starting" ]; then
304                 echo ""
305                 show "Waiting for MySQL to start"
306                 busy
307
308                 # while the pid is running, mysql is starting up
309                 # if the pidfile was created, it started up successfully
310                 # if either case fails we break and report status
311                 while true; do
312                         [ -d /proc/$pid ] || break
313                         [ -f "$MYSQL_PIDFILE" ] && break
314                         sleep 0.2
315                 done
316         fi
317
318         mysqlstatus "$clusterdir" start
319         if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
320                 ok
321         elif [ "$MYSQL_STATUS" = "died" ]; then
322                 RETVAL=1
323                 died
324         else
325                 RETVAL=1
326                 fail
327         fi
328 }
329
330 # stop mysql
331 mysqlstop() {
332         local clusterdir="$1"
333         mysqlstatus "$clusterdir" stop
334         msg_stopping "MySQL $clusterdir"
335         busy
336
337         # try graceful shutdown -- send shutdown command
338         # requires mysql_sysadmin user proper privs
339         /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
340         mysqlstatus "$clusterdir" stop
341
342         if [ "$MYSQL_PID" != "unknown" ]; then
343                 kill -TERM "$MYSQL_PID" 2> /dev/null
344                 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
345                         [ -d "/proc/$MYSQL_PID" ] || break
346                         sleep 0.1
347                 done
348         fi
349         
350         mysqlstatus "$clusterdir" stop
351         if [ "$MYSQL_STATUS" = "died" ]; then
352                 died
353         elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
354                 fail
355         else
356                 ok
357         fi
358 }
359
360 # report slave status
361 # uses MYSQL_SOCKET - path to mysql socket
362 slave_status() {
363         if [ ! -x /usr/bin/mysql ]; then
364                 echo >&2 "Slave status not available: 'mysql' program not installed."
365                 return
366         fi
367
368         # see if slave status can be reported
369         local err=0 slave_status=$(mysql --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" -e 'show slave status\G')
370         if [ -z "$slave_status" ]; then
371                 # slave not setup
372                 return
373         fi
374
375         printf "Slave Status:\n"
376
377         set -f
378         eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
379                 k = tolower($1);
380                 v = substr($0, length($1) + 3);
381                 gsub(/\\/, "\\\\\\", v);
382                 gsub(/"/, "\\\"", v);
383                 gsub(/`/, "\\`", v);
384                 gsub(/\$/, "\\$", v);
385                 gsub(/\$/, "\\$", v);
386                 printf("%s=\"%s\";\n", k, v);
387         }')
388         set +f
389
390         if [ "$slave_io_running" != "Yes" ]; then
391                 printf "\tSlave IO not running\n"
392                 err=1
393         fi
394         if [ "$slave_sql_running" != "Yes" ]; then
395                 printf "\tSlave SQL not running\n"
396                 err=1
397         fi
398
399         if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
400                 printf "\tERROR %s: %s\n" "$last_errno" "$last_error"
401         fi
402
403         if [ "$master_log_file" != "$relay_master_log_file" ]; then
404                 printf "\tERROR logfile mismatch (%s)\n" "$relay_master_log_file"
405                 err=1
406         fi
407
408         if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
409                 printf "\tERROR No info about master\n"
410                 err=1
411                 return
412         fi
413
414         diff=$(($read_master_log_pos - $exec_master_log_pos))
415         printf "\tread pos: %s (%s) (host: %s:%d)\n" "$read_master_log_pos" "$master_log_file" "$master_host" "$master_port"
416         printf "\texec pos: %s\n" "$exec_master_log_pos"
417         printf "\tdiff: %s\n" "$diff"
418 }
419
420 #
421 # check for running mysql instances; if any instance is running then
422 # create subsys lock file
423 #
424 mysqlsubsys() {
425         # check for every defined db cluster in sysconfig file
426         for mysqldir in $DB_CLUSTERS; do
427                 mysqlstatus "$mysqldir"
428                 if [ "$MYSQL_STATUS" = "running" ]; then
429                         touch /var/lock/subsys/mysql
430                         return
431                 fi
432         done
433         rm -f /var/lock/subsys/mysql
434 }
435
436 mysqlinit() {
437         local clusterdir="$1"
438
439         if [ -f /etc/mysqld.conf ]; then
440                 nls "Running in \`no cluster compat' mode: can't initialize database."
441                 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
442                 exit 1
443         fi
444
445         if [ -f "$clusterdir/mysqld.conf" ]; then
446                 mysqlgetconfig "$clusterdir"
447         else
448                 MYSQL_USER="mysql"
449                 MYSQL_CLUSTER_DIR="$clusterdir"
450                 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
451                 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
452                 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
453
454                 # this $MYSQL_CONFIG will be created later
455                 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
456         fi
457
458         show "Initializing cluster %s" "$clusterdir"; started
459
460         # Check if not exist init database
461         if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
462                 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
463                 nls "before initializing database."
464                 nls "For now skipping cluster %s." "$clusterdir"
465                 exit 6
466         fi
467
468         show "Initializing MySQL database for $MYSQL_DATA_DIR"
469         busy
470         TMP=/tmp TMPDIR=/tmp
471
472         mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
473         # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
474         chown root:root "$MYSQL_CLUSTER_DIR"
475         chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
476         chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
477
478         if [ -f $sharedir/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
479                 sed -e "
480                         s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
481                         s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
482                         s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
483                         s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
484                 " $sharedir/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
485                 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
486                 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
487         fi
488
489         ok=0
490         /usr/sbin/mysqld \
491                 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
492                 --initialize \
493                 --skip-grant-tables \
494                 --datadir=$MYSQL_DATA_DIR \
495                 --user=$MYSQL_USER \
496                 --slave-load-tmpdir=$MYSQL_DATA_DIR \
497                 --tmpdir=$MYSQL_DATA_DIR \
498                 --log-error=$MYSQL_ERRLOG \
499                 && ok=1
500         [ -f $MYSQL_DATA_DIR/mysql/user.frm ] || ok=0
501
502         if [ "$ok" = 1 ]; then
503                 ok
504                 cat << END_OF_MSG
505
506 PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
507
508 CURRENT TEMPORARY ROOT PASSWORD CAN BE FOUND IN LOG
509 (grep for "A temporary password is generated" string):
510 $MYSQL_ERRLOG
511
512
513 Start database:
514 $ service mysql start
515
516 and set passwords:
517
518 FIXME FIXME: For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
519 echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
520
521 For 'root' user (ALL privileges, DB admin), paste command with new password:
522 ALTER USER 'root'@'localhost' IDENTIFIED BY 'newpassword'; FLUSH PRIVILEGES;
523
524 into command:
525 $ mysql -u root -p -S $MYSQL_SOCKET
526
527 NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
528 mysqladmin section. See the manual for more instructions.
529 (This user is used at logs rotation and server shutdown)
530
531 END_OF_MSG
532         else
533                 fail
534                 cat << END_OF_MSG
535 ERROR:
536 ERROR:
537 ERROR: Installation FAILED!
538 ERROR:
539 ERROR:
540
541 Examine the logs in $MYSQL_ERRLOG for more information. You can
542 also try to start the mysqld daemon with:
543
544 /usr/sbin/mysqld --skip-grant &
545
546 You can use the command line tool mysql to connect to the mysql
547 database and look at the grant tables:
548
549 shell> mysql -u mysql mysql
550 mysql> show tables
551
552 Try 'mysqld --help' if you have problems with paths. Setting on
553 logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
554 may be helpful. The latest information about MySQL is available on the
555 web at http://www.mysql.com/.
556
557 Please check PLD Linux ftp site for newer versions of this package.
558
559 Please consult the MySQL manual section: 'Problems running
560 mysql_install_db', and the manual section that describes problems on
561 your OS. Another information source is the MySQL email archive.
562
563 END_OF_MSG
564                 exit 1
565         fi
566
567         # if it's first server, register as default
568         if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
569                 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
570                 ln -s "$sock" /var/lib/mysql/mysql.sock
571         fi
572         # same for config, move to /etc
573         if [ ! -e /etc/mysql/mysqld.conf ]; then
574                 mv "$MYSQL_CLUSTER_DIR/mysqld.conf" /etc/mysql/mysqld.conf
575         fi
576 }
577
578 #
579 # End of useful functions.
580 #
581
582 start() {
583         local mysqldir
584         for mysqldir in $DB_CLUSTERS; do
585                 mysqlstatus "$mysqldir" start
586                 if [ "$MYSQL_STATUS" = "running" ]; then
587                         msg_already_running "MySQL $mysqldir"
588                 else
589                         mysqlstart "$mysqldir"
590                 fi
591         done
592         mysqlsubsys
593 }
594
595 stop() {
596         local mysqldir
597         for mysqldir in $DB_CLUSTERS; do
598                 mysqlstatus "$mysqldir" stop
599                 if [ "$MYSQL_STATUS" = "not running" ]; then
600                         msg_not_running "MySQL $mysqldir"
601                 else
602                         mysqlstop "$mysqldir"
603                 fi
604         done
605         mysqlsubsys
606 }
607
608 condrestart() {
609         if [ ! -f /var/lock/subsys/mysql ]; then
610                 msg_not_running "MySQL"
611                 RETVAL=$1
612                 return
613         fi
614
615         stop
616         start
617 }
618
619 status() {
620         local mysqldir addr port socket pid pids running datadir 
621         RETVAL=3
622         for mysqldir in $DB_CLUSTERS; do
623                 mysqlstatus "$mysqldir"
624                 if [ "$MYSQL_STATUS" = "running" ]; then
625                         RETVAL=0
626                         addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
627                         port=${MYSQL_PORT:-3306}
628                         socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
629                         pid=$MYSQL_PID
630                         nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
631                         [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
632                         nls "\tunix: %s\n" "$socket"
633
634                         MYSQL_SOCKET=$socket slave_status
635
636                         pids="$pids/$MYSQL_PID/"
637                         progress "$MYSQL_STATUS"
638                 else
639                         show "MySQL cluster %s" "$mysqldir"
640                         progress "$MYSQL_STATUS" "$CFAIL"
641                 fi
642                 echo
643         done
644
645         for pid in $(/sbin/pidof mysqld); do
646                 if [[ $pids != */$pid/* ]]; then
647                         running="$running $pid"
648                 fi
649         done
650
651         if [ $# = 1 -a "$running" ]; then
652                 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
653                 # see if we can display their status
654                 for pid in $running; do
655                         datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
656                         datadir=${datadir#--datadir=} # strip --datadir
657                         mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
658                         mysqlstatus "$mysqldir"
659                         if [ "$MYSQL_STATUS" = "running" ]; then
660                                 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
661                                 port=${MYSQL_PORT:-3306}
662                                 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
663                                 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
664                                 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
665                                 nls "\tunix: %s\n" "$socket"
666
667                                 MYSQL_SOCKET=$socket slave_status
668
669                                 progress "$MYSQL_STATUS"
670                         else
671                                 show "MySQL cluster %s" "$mysqldir"
672                                 progress "$MYSQL_STATUS" "$CFAIL"
673                         fi
674                         echo
675                 done
676         fi
677 }
678
679 RETVAL=0
680 case "$action" in
681   start)
682         start
683         ;;
684   stop)
685         stop
686         ;;
687   restart)
688         stop
689         start
690         ;;
691   try-restart)
692         condrestart 0
693         ;;
694   force-reload)
695         condrestart 7
696         ;;
697   init)
698         for mysqldir in $DB_CLUSTERS; do
699                 mysqlinit "$mysqldir"
700         done
701         exit $?
702         ;;
703   flush-logs)
704         for mysqldir in $DB_CLUSTERS; do
705                 mysqlgetconfig "$mysqldir"
706                 # just if mysqld is really running
707                 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
708                         /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
709                 fi
710         done
711         ;;
712   status)
713         status
714         ;;
715   *)
716         msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
717         exit 3
718 esac
719
720 exit $RETVAL
This page took 0.128079 seconds and 3 git commands to generate.